//
//  AppDelegate.m
//  LDPeripheralDemo
//
//  Created by Søren Toft Odgaard on 8/15/13.
//  Copyright (c) 2013 LEGO. All rights reserved.
//

#import "AppDelegate.h"
#import "LELogger.h"
#import "LogCollector.h"
#import "Layout.h"

#ifdef TPA_ENABLED
#import "TPAManager.h"
#endif

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
#ifdef TPA_ENABLED
    [[TPAManager sharedManager] setBaseUrl:@"https://tpa.trifork.com/" projectUuid:@"46416f87-2a61-4550-8a22-80fa33221a4e"];
    [TPAManager sharedManager].loggingDestinations = TPALoggingDestinationConsole|TPALoggingDestinationRemote;
    [TPAManager sharedManager].updateNotificationsEnabled = YES;
    [TPAManager sharedManager].crashReportingEnabled = YES;
    [TPAManager sharedManager].sessionRecordingEnabled = YES;
#endif

#ifdef DEBUG
    [LELogger defaultLogger].logLevel = LELoggerLevelDebug;
#else
    [LELogger defaultLogger].logLevel = LELoggerLevelWarn;
#endif

    [LELogger defaultLogger].logWriter = [LogCollector sharedInstance];

    [Layout setUpDefaultAppearance];

    // Preloads keyboard so there's no lag on initial keyboard appearance. (work-around for an iOS7 bug)
    UITextField *lagFreeField = [[UITextField alloc] init];
    [self.window addSubview:lagFreeField];
    [lagFreeField becomeFirstResponder];
    [lagFreeField resignFirstResponder];
    [lagFreeField removeFromSuperview];
    
    
    return YES;
}
							
- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
