//
//  ColorValueTransformer.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 23/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "ColorValueTransformer.h"
#import <AppKit/AppKit.h>

@implementation ColorValueTransformer

+ (Class)transformedValueClass
{
    return [NSColor class];
}

+ (BOOL)allowsReverseTransformation
{
    return YES;
}

- (id)transformedValue:(id)value
{
    if (![value isKindOfClass:[CIColor class]]) {
        return nil;
    }
    return [NSColor colorWithCIColor:(CIColor *)value];
}

- (id)reverseTransformedValue:(id)value
{
    if (![value isKindOfClass:[NSColor class]]) {
        return nil;
    }
    return [[CIColor alloc] initWithColor:(NSColor *)value];
}

@end
