//
// Created by Søren Toft Odgaard on 08/05/14.
// Copyright (c) 2014 LEGO. All rights reserved.
//

#import "CurrentSensorDetailDataSource.h"
#import "LECurrentSensor.h"
#import "LEInputFormat.h"


@implementation CurrentSensorDetailDataSource {

    LECurrentSensor *_currentSensor;
}

- (instancetype)initWithService:(LEService *)service tableView:(UITableView *)tableView
{
    self = [super initWithService:service tableView:tableView];
    if (self) {
        _currentSensor = (LECurrentSensor *) self.service;
    }

    [self updateInputValue];
    [self updateInputFormat];

    return self;
}

- (void)updateInputValue
{
    [super updateInputValue];
    if (_currentSensor.inputFormat.unit == LEInputFormatUnitSI) {
        self.inputValueLabel.text = [NSString stringWithFormat:@"%.2f mA", _currentSensor.milliAmp];
    } else if (_currentSensor.inputFormat.unit == LEInputFormatUnitPercentage) {
        self.inputValueLabel.text = [NSString stringWithFormat:@"%ld%%", (long) _currentSensor.valueAsInteger];
    } else {
        self.inputValueLabel.text = [NSString stringWithFormat:@"%ld", (long) _currentSensor.valueAsInteger];
    }
}

- (void)updateInputFormat
{
    [super updateInputFormat];
    self.inputModeLabel.text = @"Default";
}


@end