//
//  EditDeviceNameViewController.m
//  LEGODeviceDemo
//
//  Created by Søren Toft Odgaard on 05/05/14.
//  Copyright (c) 2014 LEGO. All rights reserved.
//

#import "EditDeviceNameViewController.h"
#import "LEDevice.h"
#import "LEDeviceInfo.h"

@implementation EditDeviceNameViewController {
    
    IBOutlet UITextField *_deviceNameField;
    
    IBOutlet UILabel *_firmwareRevisionLabel;
    IBOutlet UILabel *_hardwareRevisionLabel;
    IBOutlet UILabel *_softwareRevisionLabel;
    IBOutlet UILabel *_manufacturerNameLabel;
    
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    _deviceNameField.text = self.device.name;

    _firmwareRevisionLabel.text = [self presentableStringFromString:self.device.deviceInfo.firmwareRevision.stringRepresentation];
    _hardwareRevisionLabel.text = [self presentableStringFromString:self.device.deviceInfo.hardwareRevision.stringRepresentation];
    _softwareRevisionLabel.text = [self presentableStringFromString:self.device.deviceInfo.softwareRevision.stringRepresentation];
    _manufacturerNameLabel.text = [self presentableStringFromString:self.device.deviceInfo.manufacturerName];
}

- (NSString *)presentableStringFromString:(NSString *)string
{
    if (!string) {
        return @"N/A";
    } else {
        return string;
    }
}


- (IBAction)sendUpdateTouched:(id)sender
{
    if (_deviceNameField.text.length > 0) {
        self.device.name = _deviceNameField.text;
        [self.navigationController popViewControllerAnimated:YES];
    }
}



@end
