//
//  ErrorLogViewController.m
//  LEGODeviceDemo
//
//  Created by Søren Toft Odgaard on 29/04/14.
//  Copyright (c) 2014 LEGO. All rights reserved.
//

#import "ErrorLogViewController.h"
#import "LogCollector.h"


@implementation ErrorLogViewController {

    IBOutlet UITextView *_textView;
    NSAttributedString *_currentLogText;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self logUpdated];
    [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(logUpdated) userInfo:nil repeats:YES];
}


- (void)logUpdated
{
    if (_showDebugLog) {
        self.title = @"Debug Log";
        if ([_currentLogText isEqualToAttributedString:[LogCollector sharedInstance].debugLog]) {
            return;
        }
        _currentLogText = [LogCollector sharedInstance].debugLog;
    } else {
        self.title = [NSString stringWithFormat:@"Errors(%lu)", (unsigned long) [LogCollector sharedInstance].errorCount];
        if ([_currentLogText isEqualToAttributedString:[LogCollector sharedInstance].errorLog]) {
            return;
        }
        _currentLogText = [LogCollector sharedInstance].errorLog;
    }

    _textView.attributedText = _currentLogText;
    [self performSelector:@selector(adjustLogScrollView) withObject:nil afterDelay:0.2];
}

- (void)adjustLogScrollView
{
    if (_textView.contentSize.height > _textView.frame.size.height) {
        CGPoint bottomOffset = CGPointMake(0, _textView.contentSize.height - _textView.bounds.size.height);
        [_textView setContentOffset:bottomOffset animated:YES];
    }
}

- (IBAction)clearLogTouched:(id)sender {
    [[LogCollector sharedInstance] clearLog];
    [self logUpdated];
}

@end
