//
//  LEInputFormat+Mutable.h
//  LEGODeviceDemo-OSX
//
//  Created by Bartlomiej Hyzy on 06/03/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import <LEGODevice/LEGODevice.h>

// This category exposes the properties of LEInputFormat as writable values in order to support bindings.
// LEInputFormat itself is conceptually an immutable class.
@interface LEInputFormat (Mutable) <NSCopying>

@property (nonatomic, readwrite) uint8_t revision;
@property (nonatomic, readwrite) uint8_t connectID;
@property (nonatomic, readwrite) uint8_t typeID;
@property (nonatomic, readwrite) uint8_t mode;
@property (nonatomic, readwrite) uint32_t deltaInterval;
@property (nonatomic, readwrite) LEInputFormatUnit unit;
@property (nonatomic, readwrite, getter=isNotificationsEnabled) BOOL notificationsEnabled;
@property (nonatomic, readwrite) uint8_t numberOfBytes;

@end
