//
//  LEMotionSensor+UI.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 19/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "LEMotionSensor+UI.h"

@implementation LEMotionSensor (UI)

- (NSString *)formattedValueString
{
    NSString *value;
    
    switch (self.motionSensorMode) {
        case LEMotionSensorModeDetect:
            if (self.inputFormat.unit == LEInputFormatUnitPercentage) {
                value = [NSString stringWithFormat:@"%ld%%", (long)self.distance];
            } else if (self.inputFormat.unit == LEInputFormatUnitSI) {
                value = [NSString stringWithFormat:@"%.2f", self.distance];
            } else {
                value = [NSString stringWithFormat:@"%ld", (long)self.distance];
            }
            break;
        case LEMotionSensorModeCount:
            value = [NSString stringWithFormat:@"%ld", (long)self.count];
            break;
        case LEMotionSensorModeUnknown:
            break;
    }
    
    return value;
}

- (NSString *)formattedModeString
{
    NSString *mode;
    
    switch (self.motionSensorMode) {
        case LEMotionSensorModeDetect:
            mode = @"Detect";
            break;
        case LEMotionSensorModeCount:
            mode = @"Count";
            break;
        case LEMotionSensorModeUnknown:
            break;
    }
    
    return mode;
}

@end
