//
//  LEMotor+UI.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 19/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "LEMotor+UI.h"

@implementation LEMotor (UI)

- (NSString *)formattedValueString
{
    return @(self.power).stringValue;
}

- (NSString *)formattedModeString
{
    NSString *mode;
    
    switch (self.direction) {
        case LEMotorDirectionDrifting:
            mode = @"Drifting";
            break;
        case LEMotorDirectionBraking:
            mode = @"Braking";
            break;
        case LEMotorDirectionLeft:
            mode = @"Left";
            break;
        case LEMotorDirectionRight:
            mode = @"Right";
            break;
    }
    
    return mode;
}

- (NSString *)statusDescription
{
    NSString *status;
    
    switch (self.direction) {
        case LEMotorDirectionDrifting:
            status = @"Drifting";
            break;
        case LEMotorDirectionBraking:
            status = @"Braking";
            break;
        case LEMotorDirectionLeft:
            status = [NSString stringWithFormat:@"Motor left %lu", (unsigned long)self.power];
            break;
        case LEMotorDirectionRight:
            status = [NSString stringWithFormat:@"Motor right %lu", (unsigned long)self.power];
            break;
    }
    
    return status;
}

@end
