//
//  LERGBLight+UI.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 19/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "LERGBLight+UI.h"
#import <QuartzCore/QuartzCore.h>

@implementation LERGBLight (UI)

- (NSString *)formattedValueString
{
    return [NSString stringWithFormat:@"R:%d G:%d B:%d",
            (int)(self.color.red * 255), (int)(self.color.green * 255), (int)(self.color.blue * 255)];
}

- (NSString *)formattedModeString
{
    return @"Default";
}

- (BOOL)inDiscreteMode
{
    return self.rgbMode == self.discreteModeIndex;
}

- (BOOL)inAbsoluteMode
{
    return self.rgbMode == self.absoluteModeIndex;
}

+ (NSSet *)keyPathsForValuesAffectingValueForKey:(NSString *)key
{
    NSSet *keyPaths = [super keyPathsForValuesAffectingValueForKey:key];
    if ([@[@"inDiscreteMode", @"inAbsoluteMode"] containsObject:key]) {
        keyPaths = [keyPaths setByAddingObject:@"rgbMode"];
    }
    return keyPaths;
}

@end
