//
//  LEService+UI.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 23/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "LEService+UI.h"
#import "LEServiceFormatter.h"

@implementation LEService (UI)

- (NSString *)valueString
{
    NSString *value;
    if ([self respondsToSelector:@selector(formattedValueString)]) {
        value = [(id <LEServiceFormatter>)self formattedValueString];
    } else {
        value = self.valueData.description;
    }
    return value.length > 0 ? value : @"?";
}

- (NSString *)modeString
{
    NSString *value;
    if ([self respondsToSelector:@selector(formattedModeString)]) {
        value = [(id <LEServiceFormatter>)self formattedModeString];
    }
    return value.length > 0 ? value : @"?";
}

- (NSString *)typeDescription
{
    return [NSString stringWithFormat:@"%@ (%@)", @(self.connectInfo.type), self.connectInfo.typeString];
}

+ (NSSet *)keyPathsForValuesAffectingValueString
{
    return [NSSet setWithObject:@"valueData"];
}

+ (NSSet *)keyPathsForValuesAffectingModeString
{
    return [NSSet setWithObject:@"inputFormat.mode"];
}

@end
