//
//  LETiltSensor+UI.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 19/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "LETiltSensor+UI.h"

@implementation LETiltSensor (UI)

- (NSString *)formattedValueString
{
    NSString *value;
    
    switch (self.tiltSensorMode) {
        case LETiltSensorModeAngle:
            if (self.inputFormat.unit == LEInputFormatUnitRaw) {
                value = [NSString stringWithFormat:@"%ld, %ld", (long)self.angle.x, (long)self.angle.y];
            } else if (self.inputFormat.unit == LEInputFormatUnitSI) {
                value = [NSString stringWithFormat:@"%.2f, %.2f", self.angle.x, self.angle.y];
            } else if (self.inputFormat.unit == LEInputFormatUnitPercentage) {
                value = [NSString stringWithFormat:@"%lu%%, %lu%%", (unsigned long)self.angle.x, (unsigned long)self.angle.y];
            }
            break;
        case LETiltSensorModeTilt:
            value = [self stringFromDirection:self.direction];
            break;
        case LETiltSensorModeCrash:
            value = [NSString stringWithFormat:@"%ld, %ld, %ld", (long)self.crash.x, (long)self.crash.y, (long)self.crash.z];
            break;
        case LETiltSensorModeUnknown:
            break;
    }
    
    return value;
}

- (NSString *)formattedModeString
{
    NSString *mode;
    
    switch (self.tiltSensorMode) {
        case LETiltSensorModeAngle:
            mode = @"Angle";
            break;
        case LETiltSensorModeTilt:
            mode = @"Tilt";
            break;
        case LETiltSensorModeCrash:
            mode = @"Crash";
            break;
        case LETiltSensorModeUnknown:
            break;
    }
    
    return mode;
}

- (NSString *)stringFromDirection:(LETiltSensorDirection)direction
{
    switch (direction) {
        case LETiltSensorDirectionBackward:
            return @"Backward";
        case LETiltSensorDirectionRight:
            return @"Right";
        case LETiltSensorDirectionNeutral:
            return @"Neutral";
        case LETiltSensorDirectionForward:
            return @"Forward";
        case LETiltSensorDirectionLeft:
            return @"Left";
        default:
            return nil;
    }
}

@end
