//
// Created by Søren Toft Odgaard on 12/05/14.
// Copyright (c) 2014 LEGO. All rights reserved.
//

#import "Layout.h"

@implementation Layout {

}

+ (void)setUpDefaultAppearance
{
    UIButton *button = [[UIButton alloc] init];
    [[UIButton appearance] setTitleColor:button.tintColor forState:UIControlStateNormal];
    [[UIButton appearance] setTitleColor:[UIColor whiteColor] forState:UIControlStateHighlighted];
}

+ (UITableViewCell *)createButtonCellWithTitle:(NSString *)title target:(id)target action:(SEL)action
{
    UITableViewCell *cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:nil];
    UIButton *button = [[UIButton alloc] init];
    [button setTitle:title forState:UIControlStateNormal];
    [cell.contentView addSubview:button];
    button.translatesAutoresizingMaskIntoConstraints = NO;
    [cell.contentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"H:|[button]|" options:0 metrics:nil views:@{ @"button" : button }]];
    [cell.contentView addConstraints:[NSLayoutConstraint constraintsWithVisualFormat:@"V:|[button]|" options:0 metrics:nil views:@{ @"button" : button }]];
    [button addTarget:target action:action forControlEvents:UIControlEventTouchUpInside];
    return cell;


}
@end