//
//  LogCollector.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 20/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "LogCollector.h"
#import "LogMessage.h"
#import <LEGODevice/LEGODevice.h>

@interface LogCollector () <LELogWriter>

@property (strong, nonatomic, readwrite) NSArray *messages;

@end

@implementation LogCollector

#pragma mark - Interface Methods

- (instancetype)initWithLogger:(LELogger *)logger
{
    NSParameterAssert(logger != nil);
    self = [super init];
    if (self != nil) {
        _logger = logger;
        _messages = [NSArray new];
        logger.logWriter = self;
        logger.logLevel = LELoggerLevelVerbose;
    }
    return self;
}

- (void)clear
{
    [self setValue:[NSArray new] forKey:@"messages"];
}

#pragma mark - LELogWriter

- (void)writeMessage:(NSString *)message logLevel:(LELoggerLevel)level
{
    LogMessage *entry = [LogMessage messageWithLevel:level text:message];
    
    NSMutableArray *mutableMessages = [self mutableArrayValueForKey:@"messages"];
    [mutableMessages addObject:entry];
}

@end
