//
//  LogMessage.h
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 20/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <LEGODevice/LEGODevice.h>

// Represents a single entry in a device message log.
@interface LogMessage : NSObject

@property (strong, nonatomic, readonly) NSDate *timestamp;
@property (assign, nonatomic, readonly) LELoggerLevel logLevel;
@property (copy, nonatomic, readonly) NSString *message;

- (instancetype)initWithTimestamp:(NSDate *)timestamp level:(LELoggerLevel)level message:(NSString *)message;

+ (LogMessage *)messageWithLevel:(LELoggerLevel)level text:(NSString *)text;

+ (NSString *)stringForLogLevel:(LELoggerLevel)level;

@end
