//
//  LogMessage.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 20/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "LogMessage.h"

@implementation LogMessage

- (instancetype)initWithTimestamp:(NSDate *)timestamp level:(LELoggerLevel)level message:(NSString *)message
{
    self = [super init];
    if (self != nil) {
        _timestamp = timestamp;
        _logLevel = level;
        _message = [message copy];
    }
    return self;
}

+ (LogMessage *)messageWithLevel:(LELoggerLevel)level text:(NSString *)text
{
    return [[self alloc] initWithTimestamp:[NSDate date] level:level message:text];
}

+ (NSString *)stringForLogLevel:(LELoggerLevel)level
{
    switch (level) {
        case LELoggerLevelFatal:
            return @"FATAL";
        case LELoggerLevelError:
            return @"Error";
        case LELoggerLevelWarn:
            return @"Warning";
        case LELoggerLevelInfo:
            return @"Info";
        case LELoggerLevelDebug:
            return @"Debug";
        case LELoggerLevelVerbose:
            return @"Verbose";
        default:
            return @"";
    }
}

@end
