//
//  MessageLogFilter.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 20/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "MessageLogFilter.h"
#import <LEGODevice/LEGODevice.h>
#import "LogMessage.h"

@implementation MessageLogFilter

- (instancetype)initWithName:(NSString *)name value:(NSPredicate *)value
{
    self = [super init];
    if (self != nil) {
        _name = name;
        _value = value;
    }
    return self;
}

+ (NSArray *)levelFilters
{
    NSMutableArray *filters = [NSMutableArray new];
    
    for (NSUInteger level = (NSUInteger)LELoggerLevelVerbose; level <= (NSUInteger)LELoggerLevelFatal; ++level) {
        NSString *name = [LogMessage stringForLogLevel:(LELoggerLevel)level];
        NSPredicate *value = [NSPredicate predicateWithFormat:@"logLevel >= %@", @(level)];
        MessageLogFilter *filter = [[MessageLogFilter alloc] initWithName:name value:value];
        [filters addObject:filter];
    }
    
    return [filters copy];
}

@end
