//
// Created by Søren Toft Odgaard on 08/05/14.
// Copyright (c) 2014 LEGO. All rights reserved.
//

#import "MotionSensorDetailDataSource.h"
#import "LEMotionSensor.h"
#import "LEInputFormat.h"


@implementation MotionSensorDetailDataSource {

    LEMotionSensor *_motionSensor;
}

- (instancetype)initWithService:(LEService *)service tableView:(UITableView *)tableView
{
    self = [super initWithService:service tableView:tableView];
    if (self) {
        _motionSensor = (LEMotionSensor *) self.service;
    }

    [self updateInputValue];
    [self updateInputFormat];

    return self;
}

- (void)updateInputValue
{
    [super updateInputValue];
    switch (_motionSensor.motionSensorMode) {
        case LEMotionSensorModeDetect:
            if (_motionSensor.inputFormat.unit == LEInputFormatUnitPercentage) {
                self.inputValueLabel.text = [NSString stringWithFormat:@"%ld%%", (long) _motionSensor.distance];
            } else if (_motionSensor.inputFormat.unit == LEInputFormatUnitSI) {
                self.inputValueLabel.text = [NSString stringWithFormat:@"%.2f", _motionSensor.distance];
            } else {
                self.inputValueLabel.text = [NSString stringWithFormat:@"%ld", (long) _motionSensor.distance];
            }
            break;
        case LEMotionSensorModeCount:
            self.inputValueLabel.text = [NSString stringWithFormat:@"%ld", (long) _motionSensor.count];
            break;
        case LEMotionSensorModeUnknown:
            break;
    }
}

- (void)updateInputFormat
{
    [super updateInputFormat];
    switch (_motionSensor.motionSensorMode) {
        case LEMotionSensorModeDetect:
            self.inputModeLabel.text = @"Detect";
            break;
        case LEMotionSensorModeCount:
            self.inputModeLabel.text = @"Count";
            break;
        case LEMotionSensorModeUnknown:
            self.inputModeLabel.text = @"?";
            break;
    }
}

@end