//
//  PiezoPlayerKey.h
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 25/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <LEGODevice/LEGODevice.h>

// Custom control representing a single key inside a keyboard of available tones possible to play using the piezoelectric player.
// A corresponding note is set through the control's 'title' and is played as long the key is pressed down.
@interface PiezoPlayerKey : NSControl

@property (copy, nonatomic) NSString *title;
@property (assign, nonatomic, readonly, getter=isPressed) BOOL pressed;

@property (assign, nonatomic, readonly) LEPiezoTonePlayerNote note;

@end
