//
// Created by Søren Toft Odgaard on 20/05/14.
// Copyright (c) 2014 LEGO. All rights reserved.
//

#import "PiezoTonePiano.h"
#import "PiezoTonePianoKeyView.h"
#import "LEPiezoTonePlayer.h"


@interface PiezoTonePiano ()
@property (nonatomic, strong) LEPiezoTonePlayer *piezoPlayer;
@end

@implementation PiezoTonePiano {

}

- (id)initWithFrame:(CGRect)frame piezoPlayer:(LEPiezoTonePlayer *)piezoPlayer
{
    self = [super initWithFrame:frame];
    if (self) {
        self.piezoPlayer = piezoPlayer;
        [self addSubview:[self createPianoButtonWithTitle:@"C" note:LEPiezoTonePlayerNoteC buttonNumber:0]];
        [self addSubview:[self createPianoButtonWithTitle:@"D" note:LEPiezoTonePlayerNoteD buttonNumber:1]];
        [self addSubview:[self createPianoButtonWithTitle:@"E" note:LEPiezoTonePlayerNoteE buttonNumber:2]];
        [self addSubview:[self createPianoButtonWithTitle:@"F" note:LEPiezoTonePlayerNoteF buttonNumber:3]];
        [self addSubview:[self createPianoButtonWithTitle:@"G" note:LEPiezoTonePlayerNoteG buttonNumber:4]];
        [self addSubview:[self createPianoButtonWithTitle:@"A" note:LEPiezoTonePlayerNoteA buttonNumber:5]];

    }
    return self;
}

- (UIView *)createPianoButtonWithTitle:(NSString *)title note:(LEPiezoTonePlayerNote)note buttonNumber:(NSUInteger)buttonNumber
{
    PiezoTonePianoKeyView *pianoButton = [[PiezoTonePianoKeyView alloc] initWithFrame:CGRectMake(10 + buttonNumber*50, 0, 45, 100)];
    pianoButton.titleLabel.text = title;

    __weak __typeof__(self) weakSelf = self;
    pianoButton.onTouchStarted = ^ {
        [weakSelf.piezoPlayer playNote:note octave:4 forMilliSeconds:0];
    };
    pianoButton.onTouchEnded = ^{
        [weakSelf.piezoPlayer stopPlaying];
    };

    return pianoButton;
}


@end