//
// Created by Søren Toft Odgaard on 20/05/14.
// Copyright (c) 2014 LEGO. All rights reserved.
//

#import "PiezoTonePianoKeyView.h"


@implementation PiezoTonePianoKeyView {
    BOOL _touchInProgress;
}

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.userInteractionEnabled = YES;
        self.backgroundColor = [UIColor whiteColor];
        self.layer.borderColor = [UIColor grayColor].CGColor;
        self.layer.borderWidth = 0.5;
        
        _titleLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, frame.size.width, frame.size.height)];
        _titleLabel.textAlignment = NSTextAlignmentCenter;
        [self addSubview:self.titleLabel];
    }
    return self;
}


- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *touch = [[event allTouches] anyObject];
    CGPoint touchPoint = [touch locationInView:self.superview];

    if (CGRectContainsPoint(self.frame, touchPoint) && self.onTouchStarted) {
        self.onTouchStarted();
        self.backgroundColor = [UIColor lightGrayColor];
        _touchInProgress = YES;
    }
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    if (!_touchInProgress) {
        return;
    }

    UITouch *touch = [[event allTouches] anyObject];
    CGPoint touchPoint = [touch locationInView:self.superview];
    if (!CGRectContainsPoint(self.frame, touchPoint) && self.onTouchEnded) {
        [self handleTouchEnded];
    }
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    [self handleTouchEnded];
}

- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event
{
    [self handleTouchEnded];
}

- (void)handleTouchEnded {
    if (!_touchInProgress) {
        return;
    }

    if (self.onTouchEnded) {
        self.onTouchEnded();
        _touchInProgress = NO;
        self.backgroundColor = [UIColor whiteColor];
    }
}



@end