//
//  RGBLightViewController.m
//  LEGODeviceDemo
//
//  Created by Bartlomiej Hyzy on 24/02/2015.
//  Copyright (c) 2015 lego. All rights reserved.
//

#import "RGBLightViewController.h"
#import <LEGODevice/LEGODevice.h>

@interface RGBLightViewController ()

@property (assign, nonatomic) NSInteger colorIndex;

@end

@implementation RGBLightViewController

- (IBAction)switchOff:(id)sender
{
    [self.rgbLight switchOff];
    self.colorIndex = self.rgbLight.colorIndex;
}

- (IBAction)switchToDefault:(id)sender
{
    [self.rgbLight switchToDefaultColor];
    self.colorIndex = self.rgbLight.colorIndex;
}

- (void)setRepresentedObject:(id)representedObject
{
    [super setRepresentedObject:representedObject];
    self.colorIndex = self.rgbLight.colorIndex;
}

- (LERGBLight *)rgbLight
{
    return (LERGBLight *)self.representedObject;
}

- (void)setColorIndex:(NSInteger)colorIndex
{
    _colorIndex = colorIndex;
    self.rgbLight.colorIndex = colorIndex;
}

@end
