//
// Created by Søren Toft Odgaard on 9/5/13.
// Copyright (c) 2013 LEGO. All rights reserved.
//
// To change the template use AppCode | Preferences | File Templates.
//


#import "SensorSimulator.h"
#import "LEBluetoothIO.h"
#import "LEBluetoothServiceDefinition.h"
#import "LEIOServiceDefinition.h"

@implementation SensorSimulator {
    BOOL _sensor0Attached;
    BOOL _sensor1Attached;
    BOOL _sensor2Attached;
    BOOL _sensor3Attached;
    LEIOServiceDefinition *_serviceDefinition;
}

- (id)init {
    self = [super initWithServiceDefinition:[LEBluetoothServiceDefinition ioServiceDefinition]];
    if (self) {
        _serviceDefinition = (LEIOServiceDefinition *) self.serviceDefinition;
        _sensor0Attached = YES;
        _sensor1Attached = YES;
        _sensor2Attached = NO;
        _sensor3Attached = NO;
    }
    return self;
}

- (CBMutableCharacteristic *)sensorValueCharacteristic
{
    return [self characteristicWithDefinition:_serviceDefinition.inputValue];
}

- (CBMutableCharacteristic *)sensorFormatCharacteristic
{
    return [self characteristicWithDefinition:_serviceDefinition.inputFormat];
}

- (CBMutableCharacteristic *)sensorCommandCharacteristic
{
    return [self characteristicWithDefinition:_serviceDefinition.inputCommand];
}

- (NSData *)sensorValues {
    NSMutableData *values = [NSMutableData new];
    if (_sensor0Attached) {
        [self appendValue:50 index:0 toBytes:values];
    }
    if (_sensor1Attached) {
        [self appendValue:100 index:1 toBytes:values];
    }
    if (_sensor2Attached) {
        [self appendValue:(unsigned char) (rand() % 10) index:2 toBytes:values];
    }
    if (_sensor3Attached) {
        [self appendValue:(unsigned char) (rand() % 10) index:3 toBytes:values];
    }
    return values;
}

- (void)appendValue:(unsigned char)value index:(unsigned char)index toBytes:(NSMutableData *)values {
    [values appendBytes:&index length:1];
    [values appendBytes:&value length:1];
}

- (void)attached:(BOOL)attached index:(NSUInteger)index {
    if (index == 0) {
        _sensor0Attached = attached;
    } else if (index == 1) {
        _sensor1Attached = attached;
    } else if (index == 2) {
        _sensor2Attached = attached;
    } else if (index == 3) {
        _sensor3Attached = attached;
    }
}


@end