//
// Created by Søren Toft Odgaard on 16/04/14.
// Copyright (c) 2014 LEGO. All rights reserved.
//

#import "SimulatorDeviceService.h"
#import "LEBluetoothServiceDefinition.h"


@implementation SimulatorDeviceService


- (id)initWithServiceDefinition:(LEBluetoothServiceDefinition *)serviceDefinition {
    self = [super init];
    if (self) {
        _serviceDefinition = serviceDefinition;
        _service = [[CBMutableService alloc] initWithType:_serviceDefinition.serviceUUID primary:YES];
        NSMutableArray *characteristics = [NSMutableArray arrayWithCapacity:_serviceDefinition.characteristicDefinitions.count];
        for (LECharacteristicDefinition *characteristicDefinition in _serviceDefinition.characteristicDefinitions) {
            CBMutableCharacteristic *characteristic = [[CBMutableCharacteristic alloc]
                    initWithType:characteristicDefinition.UUID
                    properties:(characteristicDefinition.mandatoryProperties | characteristicDefinition.recommendedProperties)
                    value:nil
                    permissions:characteristicDefinition.permissions];
            [characteristics addObject:characteristic];
        }

        _service.characteristics = characteristics;
    }

    return self;
}


- (CBMutableCharacteristic *)characteristicWithDefinition:(LECharacteristicDefinition *)definition
{
    for (CBMutableCharacteristic *characteristic in self.service.characteristics) {
        if ([definition matchesCharacteristic:characteristic]) {
            return characteristic;
        }
    }
    return nil;
}




@end