//
// Created by Søren Toft Odgaard on 17/04/14.
// Copyright (c) 2014 LEGO. All rights reserved.
//

#import "SimulatorService.h"


@implementation SimulatorService {

}

- (id)initWithName:(NSString *)name connectID:(NSUInteger)connectID hubIndex:(NSUInteger)hubIndex typeID:(NSUInteger)typeID
{
    self = [super init];
    if (self) {
        _name = name;
        _connectID = connectID;
        _hubIndex = hubIndex;
        _typeID = typeID;
    }
    return self;
}

+ (SimulatorService *)serviceWithName:(NSString *)name connectID:(NSUInteger)connectID hubIndex:(NSUInteger)hubIndex typeID:(NSUInteger)typeID
{
    return [[SimulatorService alloc] initWithName:name connectID:connectID hubIndex:hubIndex typeID:typeID];
}


#pragma mark - Encode / Decode

- (id)initWithCoder:(NSCoder *)coder
{
    self = [super init];
    if (self) {
        _name = [coder decodeObjectForKey:@"_name"];
        _connectID = [coder decodeIntForKey:@"_connectID"];
        _hubIndex = [coder decodeIntForKey:@"_hubIndex"];
        _typeID = [coder decodeIntForKey:@"_typeID"];
    }

    return self;
}

- (void)encodeWithCoder:(NSCoder *)coder
{
    [coder encodeObject:self.name forKey:@"_name"];
    [coder encodeInt:(int)self.connectID forKey:@"_connectID"];
    [coder encodeInt:(int)self.hubIndex forKey:@"_hubIndex"];
    [coder encodeInt:(int)self.typeID forKey:@"_typeID"];
}


@end

