//
// Created by Søren Toft Odgaard on 08/05/14.
// Copyright (c) 2014 LEGO. All rights reserved.
//

#import "VoltageSensorDetailDataSource.h"
#import "LEInputFormat.h"

@implementation VoltageSensorDetailDataSource {
    LEVoltageSensor *_voltageSensor;
}

- (instancetype)initWithService:(LEService *)service tableView:(UITableView *)tableView
{
    self = [super initWithService:service tableView:tableView];
    if (self) {
        _voltageSensor = (LEVoltageSensor *) self.service;
    }

    [self updateInputValue];
    [self updateInputFormat];

    return self;
}

- (void)updateInputValue
{
    [super updateInputValue];
    if (_voltageSensor.inputFormat.unit == LEInputFormatUnitSI) {
        self.inputValueLabel.text = [NSString stringWithFormat:@"%.2f mV", _voltageSensor.milliVolts];
    } else if (_voltageSensor.inputFormat.unit == LEInputFormatUnitPercentage) {
        self.inputValueLabel.text = [NSString stringWithFormat:@"%ld%%", (long) _voltageSensor.valueAsInteger];
    } else {
        self.inputValueLabel.text = [NSString stringWithFormat:@"%ld", (long) _voltageSensor.valueAsInteger];
    }
}

- (void)updateInputFormat
{
    [super updateInputFormat];
    self.inputModeLabel.text = @"Default";
}



@end