﻿using System;
using LEGODeviceUnitySDK;

namespace LegoDeviceSDK.Wrapper
{
    public interface IServiceWrapper
    {
        ILEGOServiceNativeDelegate UnityServiceDelegate { get; set; }

        void UpdateInputFormat(string deviceID, string connectID, string mode, string unit, string deltaInterval, bool notificationEnabled);
        void UpdateServiceData(string deviceID, string connectID);

        void Run(string deviceID, string connectID, string motorDirection, string power);
        void Brake(string deviceID, string connectID);
        void Drift(string deviceID, string connectID);

        void SetRGBLightMode(string deviceID, string connectID, string rgbLightMode);
        void SwitchOff(string deviceID, string connectID);
        void ChangeColor(string deviceID, string connectID, string colorJSON);
        void ChangeColorIndex(string deviceID, string connectID, string colorIndex);
        void ChangeColorToDefault(string deviceID, string connectID);

        void PlayFrequency(string deviceID, string connectID, string frequency, string milliseconds);
        void PlayNote(string deviceID, string connectID, string note, string octave, string milliseconds);
        void StopPlaying(string deviceID, string connectID);

        void SetTiltSensorMode(string deviceID, string connectID, string tiltSensorMode);
        void SetMotionSensorMode(string deviceID, string connectID, string motionSensorMode);
    }
}
