﻿using System.Runtime.CompilerServices;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Messaging;
using LegoBleTestApp.Navigation;

namespace LegoBleTestApp.ViewModel {

	public class ExtendedViewModelBase : ViewModelBase, INavigatable {

		public ExtendedViewModelBase() { }

		public ExtendedViewModelBase(IMessenger messenger) : base(messenger) { }

		protected new bool Set<T>(ref T storage, T value, [CallerMemberName]string propertyName = null) {
			return Set(propertyName, ref storage, value);
		}

		protected new bool Set<T>(ref T storage, T value, bool broadcast, [CallerMemberName]string propertyName = null) {
			return Set(propertyName, ref storage, value, broadcast);
		}

		public virtual void OnNavigatedTo() {
		}

		public virtual void OnNavigatedFrom() {
		}
	}

}