﻿using System;
using System.Globalization;
using Windows.UI;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Media;

namespace LegoBleTestApp.Converters {
	/// <summary>
	/// Converts a boolean value to an active or passive color.
	/// </summary>
	public class BooleanToActiveColorConverter : IValueConverter {

		public object Convert(object value, Type targetType, object parameter, string language) {
			// read parameter
			var inverse = parameter as string == "invert";
			if (value is bool) {
				// read value
				var val = System.Convert.ToBoolean(value);
				// if active return light grey else return transparent
				var result = val ^ inverse ? Colors.LightGray : Colors.Transparent;
				return new SolidColorBrush(result);
			}
			return null;
		}

		public object ConvertBack(object value, Type targetType, object parameter, string language) {
			throw new NotImplementedException();
		}
	}
}
