﻿using System;
using Windows.UI;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Media;
using LegoDeviceSDK.Generic;

namespace LegoBleTestApp.Converters {
	/// <summary>
	/// Converts the device state (connecting, interrogating, interrogation finished or disconnected) to a color
	/// </summary>
	public class DeviceStateToColorConverter : IValueConverter {
		
		/// <summary>
		/// Converts the device state (connecting, interrogating, interrogation finished or disconnected) to a color
		/// </summary>
		/// <param name="value">The device state</param>
		/// <param name="targetType"></param>
		/// <param name="parameter"></param>
		/// <param name="language"></param>
		/// <returns>Green when interogation finished, red when disconnected and yellow otherwise</returns>
		public object Convert(object value, Type targetType, object parameter, string language) {
			SolidColorBrush brush = null;
			var deviceState = (DeviceState) value;
			if (deviceState == DeviceState.DeviceStateInterrogationFinished) {
				brush = new SolidColorBrush(Colors.Green);
			}
			else if (deviceState == DeviceState.DeviceStateDisconnected) {
				brush = new SolidColorBrush(Colors.Red);
			}
			else {
				brush = new SolidColorBrush(Colors.Yellow);
			}
			return brush;
		}

		public object ConvertBack(object value, Type targetType, object parameter, string language) {
			throw new NotSupportedException("Converting back from Color/Brush not supported.");
		}
	}

}
