﻿using System;
using System.Collections.Generic;
using System.Text;
using Windows.UI.Xaml.Data;
using LegoDeviceSDK.Generic.Data;

namespace LegoBleTestApp.Converters
{
	/// <summary>
	/// Converts the direction of a tilt sensor to a string
	/// </summary>
  class DirectionToStringConverter : IValueConverter
  {
	  public object Convert(object value, Type targetType, object parameter, string language) {
			var direction = (TiltSensorDirection)value;
		  switch (direction) {
			  case TiltSensorDirection.TiltSensorDirectionNeutral:
				  return "Neutral";
			  case TiltSensorDirection.TiltSensorDirectionBackward:
					return "Backward";
				case TiltSensorDirection.TiltSensorDirectionForward:
					return "Forward";
				case TiltSensorDirection.TiltSensorDirectionLeft:
					return "Left";
				case TiltSensorDirection.TiltSensorDirectionRight:
					return "Right";
				case TiltSensorDirection.TiltSensorDirectionUnknown:
					return "Unknown";
				default:
					return "Unknown";
			}
	  }

	  public object ConvertBack(object value, Type targetType, object parameter, string language) {
		  throw new NotImplementedException();
	  }
  }
}
