﻿using System;
using System.Collections.Generic;
using System.Net.Http.Headers;
using System.Text;
using Windows.UI.Xaml.Data;
using LegoDeviceSDK.Generic;

namespace LegoBleTestApp.Converters
{
	/// <summary>
	/// Converts the IOType to a string
	/// </summary>
  public class IoTypeToStringConverter : IValueConverter
  {
	  public object Convert(object value, Type targetType, object parameter, string language) {
		  var type = (IoType)value;
			switch (type) {
				case IoType.IoTypeMotor:
					return "Motor";
				case IoType.IoTypeVoltage:
					return "Voltage";
				case IoType.IoTypeCurrent:
					return "Current";
				case IoType.IoTypePiezoTone:
					return "Piezo Tone";
				case IoType.IoTypeRgbLight:
					return "RGB Light";
				case IoType.IoTypeTiltSensor:
					return "Tilt Sensor";
				case IoType.IoTypeMotionSensor:
					return "Motion Sensor";
				case IoType.IoTypeGeneric:
					return "Generic";
				default:
					throw new ArgumentOutOfRangeException();
			}
	  }

	  public object ConvertBack(object value, Type targetType, object parameter, string language) {
		  throw new NotImplementedException();
	  }
  }
}
