﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Reflection;
using Newtonsoft.Json;

namespace LegoBleTestApp.Services
{
    /// <summary>
    /// INavigationParameterHandler that are compatible with the SuspensionManager.
    /// </summary>
    public class NavigationParameterHandler : INavigationParameterHandler
    {
        public object SerializeToValidValue(object value)
        {
            var isOk = value.GetType().GetTypeInfo().IsPrimitive
               || value is string
               || value is Guid;
            if (isOk)
            {
                return value;
            }
            else
            {
                //Convert to JSON string
                return JsonConvert.SerializeObject(value);
            }
        }

        public object DeserializeToValidValue(object value, Type targetType)
        {
            var isOk = targetType.GetTypeInfo().IsPrimitive
              || targetType == typeof(string)
              || targetType == typeof(Guid);

            if (isOk)
            {
                return value;
            }
            else
            {
                return JsonConvert.DeserializeObject(value as string, targetType);
            }
        }
    }
}
