﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Reflection;

namespace LegoBleTestApp.Services
{
    public class ViewResolver : IViewResolver
    {
        public string ViewNameSuffix { get; set; }
        public string ViewModelNameSuffix { get; set; }

        public string ViewModelNameSpace { get; set; }
        public string ViewNameSpace { get; set; }

        public ViewResolver()
        {
            ViewNameSuffix = "View";
            ViewModelNameSuffix = "ViewModel";

            ViewModelNameSpace = "ViewModel";
            ViewNameSpace = "Views";
        }

        public Type ResolveView(Type viewModelType)
        {
            var viewModelName = viewModelType.FullName;

            //Transfrom ViewModel to View class fullname
            var viewName = viewModelName;
            if (viewName.EndsWith(ViewModelNameSuffix))
            {
                viewName = viewName.Remove(viewName.Length - ViewModelNameSuffix.Length) + ViewNameSuffix;
            }
            viewName = viewName.Replace("." + ViewModelNameSpace + ".", "." + ViewNameSpace + ".");

            return Type.GetType(viewName);
        }

        public Type ResolveViewModel(Type viewType)
        {
            var viewName = viewType.FullName;

            //Transfrom ViewModel to View class fullname
            var viewModelName = viewName;
            if (viewModelName.EndsWith(ViewNameSuffix))
            {
                viewModelName = viewModelName.Remove(viewName.Length - ViewNameSuffix.Length) + ViewModelNameSuffix;
            }
            viewModelName = viewModelName.Replace("." + ViewNameSpace + ".", "." + ViewModelNameSpace + ".");

            return Type.GetType(viewModelName);
        }
    }
}
