﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238
using LegoBleTestApp.Common;
using LegoBleTestApp.ViewModel;

namespace LegoBleTestApp.Views {
	/// <summary>
	/// An empty page that can be used on its own or navigated to within a Frame.
	/// </summary>
	public sealed partial class PiezoTonePlayerView : BasePage {
		public PiezoTonePlayerView() {
			this.InitializeComponent();
		}

		string lastCommandParameter = "";
		void UIElement_OnPointerPressed(object sender, PointerRoutedEventArgs e) {
			var button = sender as Button;
			if(button == null)
				return;
			lastCommandParameter = (string)button.CommandParameter;
			((PiezoTonePlayerViewModel)DataContext).PlayToneCommand.Execute(lastCommandParameter);
		}

		void UIElement_OnPointerReleased(object sender, PointerRoutedEventArgs e) {
			var button = sender as Button;
			if (button == null)
				return;
			if (lastCommandParameter == (string) button.CommandParameter) {
				((PiezoTonePlayerViewModel)DataContext).StopPlayingCommand.Execute(null);
			}
		}
	}
}
