﻿using LegoDeviceSDK.Helpers;
using LegoDeviceSDK.Wrapper;

namespace LegoDeviceSDK.Bluetooth.Definitions {
	internal class BluetoothBatteryServiceDefinition : BluetoothServiceDefinition {

		internal const ushort BatteryServiceUuid = 0x180F;

		internal const ushort BatteryLevelCharacteristicUuid = 0x2A19;

		internal BluetoothBatteryServiceDefinition(IGattDeviceService gattDeviceService)
			: base(gattDeviceService) {
			Init();
		}

		void Init() {
			ServiceUuid = Windows.Devices.Bluetooth.GenericAttributeProfile.GattDeviceService.ConvertShortIdToUuid(BatteryServiceUuid);
			ServiceName = "BatteryService";

			var batteryLevel = new BluetoothCharacteristicDefinition(
							"InputValues",
							this,
							Windows.Devices.Bluetooth.GenericAttributeProfile.GattDeviceService.ConvertShortIdToUuid(BatteryLevelCharacteristicUuid),
							true,
							((int)BluetoothHelper.Properties.PROPERTY_NOTIFY | (int)BluetoothHelper.Properties.PROPERTY_NOTIFY),
							0,
							(int)BluetoothHelper.Permissions.PERMISSION_READ);

			CharacteristicDefinitions.Add(batteryLevel);
		}
	}
}
