﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using LegoBleTestApp.Wrapper;
using LegoDeviceSDK.Wrapper;

namespace LegoDeviceSDK {

	internal static class GattConfiguration {
		static IGattDeviceServiceWrapper _gattDeviceServiceWrapper = new GattDeviceServiceWrapper();
		static IDeviceInformationWrapper _deviceInformationWrapper = new DeviceInformationWrapper();

		public static IGattDeviceServiceWrapper GattDeviceServiceWrapper {
			get { return _gattDeviceServiceWrapper; }
			set { _gattDeviceServiceWrapper = value; }
		}

		public static IDeviceInformationWrapper DeviceInformationWrapper {
			get { return _deviceInformationWrapper; }
			set { _deviceInformationWrapper = value; }
		}

		public static void ChangeConfiguration(IGattDeviceServiceWrapper gattDeviceServiceWrapper,
			IDeviceInformationWrapper deviceInformationWrapper) {
			GattDeviceServiceWrapper = gattDeviceServiceWrapper;
			DeviceInformationWrapper = deviceInformationWrapper;
		}

		public static void ResetConfiguration() {
			GattDeviceServiceWrapper =  new GattDeviceServiceWrapper();
			DeviceInformationWrapper = new DeviceInformationWrapper();
		}

	}
}