﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.ApplicationModel.Contacts;
using LegoDeviceSDK.Interfaces;

namespace LegoDeviceSDK.Generic {
	internal class DefaultConsoleLogWriter : ILogWriter {
		public void WriteMessage(string message, LoggerLevel level) {
			Debug.WriteLine("{0}: {1}", LevelToString(level), message);
		}

		string LevelToString(LoggerLevel level) {
			switch (level) {
				case LoggerLevel.LoggerLevelVerbose:
					return "Verbose";
				case LoggerLevel.LoggerLevelDebug:
					return "Debug";
				case LoggerLevel.LoggerLevelInfo:
					return "Info";
				case LoggerLevel.LoggerLevelWarn:
					return "Warn";
				case LoggerLevel.LoggerLevelError:
					return "Error";
				case LoggerLevel.LoggerLevelFatal:
					return "Fatal";
				default:
					return "Info";
			}
		}
	}
}
