﻿using System;

namespace LegoDeviceSDK.Generic {
	/// <summary>
	/// Class that represents an error occuring when reading values or input formats
	/// </summary>
	internal class SdkError {
		private readonly LeDomain errorDomain;
    private readonly LeErrorCode errorCode;
    private readonly string errorMessage;

		internal enum LeDomain {DEVICE_ERROR_DOMAIN}
		internal enum LeErrorCode {BLUETOOTH_MISSING_CHARACTERISTICS, BLUETOOTH_INVALID_CHARACTERISTIC_PROPERTIES, INTERNAL_ERROR}

		public SdkError(LeDomain errorDomain, LeErrorCode errorCode, String errorMessage) {
        this.errorDomain = errorDomain;
        this.errorCode = errorCode;
        this.errorMessage = errorMessage;
    }

    public LeDomain GetErrorDomain() {
        return errorDomain;
    }

    public LeErrorCode GetErrorCode() {
        return errorCode;
    }

    public string GetErrorMessage() {
        return errorMessage;
    }

	}
}
