﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics.CodeAnalysis;

namespace LegoDeviceSDK.Wrapper {
	/// <summary>
	/// Wrapper for a Widnows Device information
	/// </summary>
	internal class DeviceInformation : IDeviceInformation {
		Windows.Devices.Enumeration.DeviceInformation deviceInformation;

		internal DeviceInformation(Windows.Devices.Enumeration.DeviceInformation deviceInformation) {
			this.deviceInformation = deviceInformation;
		}

		/// <summary>
		/// The device id
		/// </summary>
		public string Id {
			get { return deviceInformation.Id; }
		}

		/// <summary>
		/// The Device name
		/// </summary>
		public string Name {
			get { return deviceInformation.Name; }
		}

		/// <summary>
		/// The device porperties
		/// </summary>
		public IReadOnlyDictionary<String, Object> Properties {
			get { return deviceInformation.Properties; }
		}

	}
}
