﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using LegoDeviceSDK.Wrapper;

namespace LegoBleTestApp.Wrapper
{
	/// <summary>
	/// This class wraps all static Deviceinformation methods
	/// </summary>
    internal class DeviceInformationWrapper : IDeviceInformationWrapper {

			/// <summary>
			/// Find all Devices with the specified properties
			/// </summary>
			/// <param name="aqsFilter">The filter to look for</param>
			/// <param name="additionalProperties">A list of aditional properties that should be searched for</param>
			/// <returns>A list of device informations with the specified properties</returns>
	    public async Task<List<IDeviceInformation>> FindAllAsync(string aqsFilter, IEnumerable<string> additionalProperties) {
				var deviceList = await Windows.Devices.Enumeration.DeviceInformation.FindAllAsync(aqsFilter, additionalProperties);
		    return deviceList.Select(device => new DeviceInformation(device)).Cast<IDeviceInformation>().ToList();
			}
    }
}
