﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LegoDeviceSDK.Wrapper {
	/// <summary>
	/// Wrapper for the static methods of the Windows GattDeviceService
	/// </summary>
	internal class GattDeviceServiceWrapper : IGattDeviceServiceWrapper {

		/// <summary>
		/// Return the <see cref="GattDeviceService"/> with the specified Id
		/// </summary>
		/// <param name="id">The Id of the <see cref="GattDeviceService"/></param>
		/// <returns>The <see cref="GattDeviceService"/> with the specific Id</returns>
		public async Task<IGattDeviceService> FromIdAsync(string id) {
			var gatt = await Windows.Devices.Bluetooth.GenericAttributeProfile.GattDeviceService.FromIdAsync(id);
			return new GattDeviceService(gatt);
		}

		public string GetDeviceSelectorFromUuid(Guid uuid) {
			return Windows.Devices.Bluetooth.GenericAttributeProfile.GattDeviceService.GetDeviceSelectorFromUuid(uuid);
		}

	}
}
