﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.Devices.Bluetooth.GenericAttributeProfile;
using Windows.Foundation;
using Windows.Storage.Streams;

namespace LegoDeviceSDK.Wrapper {
	internal interface IGattCharacteristic {
		GattProtectionLevel ProtectionLevel { get; set; }
		Guid Uuid { get; }
		event TypedEventHandler<GattCharacteristic, GattValueChangedEventArgs> ValueChanged;
		void RegisterValueChangedCallback();

		Task<GattReadClientCharacteristicConfigurationDescriptorResult> ReadClientCharacteristicConfigurationDescriptorAsync();
		Task<GattCommunicationStatus> WriteClientCharacteristicConfigurationDescriptorAsync(GattClientCharacteristicConfigurationDescriptorValue clientCharacteristicConfigurationDescriptorValue);

		Task<GattReadResult> ReadValueAsync();
		Task<GattCommunicationStatus> WriteValueAsync(IBuffer buffer);
		Task<GattCommunicationStatus> WriteValueAsync(IBuffer buffer, GattWriteOption writeOption);
	}
}
