﻿using NUnit.Framework;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using LegoDeviceSDK.Bluetooth;

namespace LegoSDKNunitTest.SDK.Bluetooth {
    [TestFixture]
    class BluetoothMotorIoTest : BluetoothIo {
        private int connectID = 0;
        private byte[] writtenData;

        [TestCase(0, 0, 0)]
        [TestCase(0, 100, 100)]
        [TestCase(0, -100, -100)]
        [TestCase(30, 0, 30)]
        [TestCase(30, 50, 65)] // The range goes from 30-100. 50% of that places the value in the middle of that range: 65
        [TestCase(30, -50, -65)] // The range goes from 30-100. -50% of that places the value in the middle of that range: -65
        [TestCase(30, -100, -100)]
        [TestCase(30, 100, 100)]
        public void TestWriteMotorPowerIsCorrectlyTranslatedByOffset(int offset, int power, int expectedPowerWritten) {
            WriteMotorPower(power, offset, connectID);
            Assert.AreEqual(BluetoothOutputCommand.WriteMotorPowerCommand(expectedPowerWritten, connectID).Data, writtenData);
        }

        public override void WriteOutputCommand(BluetoothOutputCommand outputCommand) {
            writtenData = outputCommand.Data;
        }
    }
}
