﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using LegoDeviceSDK.Wrapper;

namespace LegoSDKNunitTest.SDK.Bluetooth.Mocks {
	public enum DeviceManagerDeviceInformationMockErrorEnum {
		Success,
		TooFewHashTags,
		TooManyHashTags,
		NoAmpersand,
	}
	public class DeviceManagerDeviceInformationMock : IDeviceInformation {
		public int Index = 1;
		public DeviceManagerDeviceInformationMockErrorEnum ErrorEnum = DeviceManagerDeviceInformationMockErrorEnum.Success;
		public string Id {
			get {
				switch (ErrorEnum) {
					case DeviceManagerDeviceInformationMockErrorEnum.Success:
						return "0#1_" + Index + "#&2#3";
					case DeviceManagerDeviceInformationMockErrorEnum.TooFewHashTags:
						return "";
					case DeviceManagerDeviceInformationMockErrorEnum.TooManyHashTags:
						return "0#1#2#3#4#5#6";
					case DeviceManagerDeviceInformationMockErrorEnum.NoAmpersand:
						return "0#1#" + Index + "$2#3";
				}
				return "";
			}
		}
		public string Name { get { return "Device: " + Index; } }
		public IReadOnlyDictionary<string, object> Properties { get; private set; }
	}
}
