﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using LegoDeviceSDK.Bluetooth.Definitions;
using LegoDeviceSDK.Helpers;
using LegoDeviceSDK.Wrapper;

namespace LegoSDKNunitTest.SDK.Bluetooth.Mocks {
	class GattDeviceServiceMock : IGattDeviceService {
		internal GattDeviceServiceMock() {
			
		}

		public IReadOnlyList<GattCharacteristic> GetCharacteristics(Guid characteristicUuid) {
			return new List<GattCharacteristic>() { new GattCharacteristicsMock(null) { Uuid= GuidHelper.GetFullGuid(IoServiceDefinition.CharacteristicInputCommandUuid)},
				new GattCharacteristicsMock(null) { Uuid= GuidHelper.GetFullGuid(IoServiceDefinition.CharacteristicInputFormatUuid)},
				new GattCharacteristicsMock(null) { Uuid= GuidHelper.GetFullGuid(IoServiceDefinition.CharacteristicInputValueUuid)},
				new GattCharacteristicsMock(null) { Uuid= GuidHelper.GetFullGuid(IoServiceDefinition.CharacteristicOutputCommandUuid)} };
		}

		public void Dispose() {
			throw new NotImplementedException();
		}

		public Guid Uuid { get; private set; }
	}
}
