﻿using NUnit.Framework;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using LegoDeviceSDK.Wrapper;
using Moq;
using LegoDeviceSDK.Interfaces;
using LegoDeviceSDK.Generic;
using LEGODeviceUnitySDK;

namespace LegoSDKNunitTest.SDK.Wrapper
{
    [TestFixture]
    public class LoggerWrapperTest
    {
        private SdkLogger logger = new SdkLogger();
        private LoggerWrapper loggerWrapper;

        [SetUp]
        public void SetUp()
        {
            loggerWrapper = new LoggerWrapper(logger);
        }

        [Test]
        public void TestSetLogLevel()
        {
            loggerWrapper.SetLogLevel(0);
            Assert.AreEqual(LoggerLevel.LoggerLevelVerbose, logger.LogLevel);

            loggerWrapper.SetLogLevel(1);
            Assert.AreEqual(LoggerLevel.LoggerLevelDebug, logger.LogLevel);

            loggerWrapper.SetLogLevel(2);
            Assert.AreEqual(LoggerLevel.LoggerLevelInfo, logger.LogLevel);

            loggerWrapper.SetLogLevel(3);
            Assert.AreEqual(LoggerLevel.LoggerLevelWarn, logger.LogLevel);

            loggerWrapper.SetLogLevel(4);
            Assert.AreEqual(LoggerLevel.LoggerLevelError, logger.LogLevel);
        }
    }

}
