package bluetooth;

import android.bluetooth.BluetoothGattCharacteristic;
import android.test.suitebuilder.annotation.SmallTest;

import junit.framework.TestCase;

import java.util.List;

import dk.lego.devicesdk.bluetooth.BluetoothHelper;

public class BluetoothHelperTest extends TestCase {

    @SmallTest
    public void testUUIDBuilding()
    {
        assertEquals(BluetoothHelper.UUIDWithPrefixCustomBase("00001560"), "00001560-1212-EFDE-1523-785FEABCD123");
        assertEquals(BluetoothHelper.UUIDWithPrefixCustomBase("001560"), "00001560-1212-EFDE-1523-785FEABCD123");
        assertEquals(BluetoothHelper.UUIDWithPrefixCustomBase("1560"), "00001560-1212-EFDE-1523-785FEABCD123");
    }

    @SmallTest
    public void testCharacteristicPropertiesToStrings() {

        int props = (BluetoothGattCharacteristic.PROPERTY_NOTIFY
                | BluetoothGattCharacteristic.PROPERTY_WRITE_NO_RESPONSE
                | BluetoothGattCharacteristic.PROPERTY_READ);

        List<String> propStrings = BluetoothHelper.arrayOfStringsFromCharacteristicProperties(props);

        assertEquals(3, propStrings.size());
        assertTrue(propStrings.contains(BluetoothHelper.Properties.PROPERTY_READ.name()));
        assertTrue(propStrings.contains(BluetoothHelper.Properties.PROPERTY_WRITE_NO_RESPONSE.name()));
        assertTrue(propStrings.contains(BluetoothHelper.Properties.PROPERTY_NOTIFY.name()));
    }
}
