package bluetooth.mocks_and_stubs;

import java.util.HashSet;
import java.util.Set;

import dk.lego.devicesdk.bluetooth.wrappers.AndroidBluetoothAdapterWrapper;
import dk.lego.devicesdk.bluetooth.wrappers.AndroidBluetoothDeviceWrapper;
import dk.lego.devicesdk.bluetooth.wrappers.AndroidBluetoothScanCallbackListener;

public class AndroidBluetoothAdapterWrapperMock implements AndroidBluetoothAdapterWrapper {

    private Set<AndroidBluetoothScanCallbackListener> listeners = new HashSet<>();

    public AndroidBluetoothAdapterWrapperMock() {
    }

    @Override
    public void startLeScan() {
        // Do nothing
    }

    @Override
    public void stopLeScan() {
        // Do nothing
    }

    @Override
    public boolean isBluetoothAvailable() {
        return true;
    }

    @Override
    public boolean isBluetoothEnabledOnDevice() {
        return true;
    }

    @Override
    public void connectCallbackListener(AndroidBluetoothScanCallbackListener listener) {
        listeners.add(listener);
    }

    public void performOnLeScanCallback(AndroidBluetoothDeviceWrapper device, int rssi, byte[] advertisementData) {
        for (AndroidBluetoothScanCallbackListener listener : listeners) {
            listener.onLeScan(device, rssi, advertisementData);
        }
    }
}
