package bluetooth.mocks_and_stubs;

import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGattCallback;
import android.content.Context;

import dk.lego.devicesdk.bluetooth.wrappers.AndroidBluetoothDeviceWrapper;

public class AndroidBluetoothDeviceWrapperMock implements AndroidBluetoothDeviceWrapper {

    private final String name;
    private final String address;
    private BluetoothGattCallback bluetoothGattCallback;

    public AndroidBluetoothDeviceWrapperMock(String name, String address) {
        this.name = name;
        this.address = address;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public String getAddress() {
        return address;
    }

    @Override
    public void connectGatt(Context context, boolean autoConnect, BluetoothGattCallback bluetoothGattCallback) {
        this.bluetoothGattCallback = bluetoothGattCallback;
    }

    public BluetoothGattCallback getBluetoothGattCallback() {
        return bluetoothGattCallback;
    }

    @Override
    public BluetoothDevice getDevice() {
        return null;
    }
}
