package bluetooth.mocks_and_stubs;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import dk.lego.devicesdk.device.ConnectInfo;
import dk.lego.devicesdk.input_output.InputFormat;
import dk.lego.devicesdk.utils.ByteUtils;

public class TestStubFactory {
    public static byte[] inputFormatWriteData(int revision,
                                              int connectId,
                                              ConnectInfo.IOType type,
                                              int mode,
                                              long deltaInterval,
                                              InputFormat.InputFormatUnit unit,
                                              boolean notificationsEnabled,
                                              int numOfBytes) {

        ByteBuffer dataBuffer = ByteBuffer.allocate(InputFormat.INPUT_FORMAT_PACKAGE_SIZE).order(ByteOrder.LITTLE_ENDIAN);

        ByteUtils.putUnsignedByte(dataBuffer, revision);
        ByteUtils.putUnsignedByte(dataBuffer, connectId);
        ByteUtils.putUnsignedByte(dataBuffer, type.getValue());
        ByteUtils.putUnsignedByte(dataBuffer, mode);

        ByteUtils.putUnsignedInt(dataBuffer, deltaInterval);

        ByteUtils.putUnsignedByte(dataBuffer, unit.getValue());
        ByteUtils.putUnsignedByte(dataBuffer, notificationsEnabled ? 1 : 0);
        ByteUtils.putUnsignedByte(dataBuffer, numOfBytes);

        return dataBuffer.array();
    }
}
