package dk.lego.devicesdk.unity;

import android.test.suitebuilder.annotation.SmallTest;

import junit.framework.TestCase;

import dk.lego.devicesdk.logging.LDSDKLogger;

public class LegoLoggerTest extends TestCase {

    private LegoLoggerWrapperImpl loggerWrapper;
    private LDSDKLogger logger;

    // --------- Setup ---------

    @Override
    public void setUp() throws Exception {
        super.setUp();

        logger = new LDSDKLogger();
        loggerWrapper = new LegoLoggerWrapperImpl(logger);
    }

    // --------- API methods ---------

    @SmallTest
    public void testSetLogLevel() throws Exception {
        loggerWrapper.setLogLevel(0);
        assertEquals(LDSDKLogger.LoggerLevel.LOGGER_LEVEL_VERBOSE, logger.getLoggerLevel());

        loggerWrapper.setLogLevel(1);
        assertEquals(LDSDKLogger.LoggerLevel.LOGGER_LEVEL_DEBUG, logger.getLoggerLevel());

        loggerWrapper.setLogLevel(2);
        assertEquals(LDSDKLogger.LoggerLevel.LOGGER_LEVEL_INFO, logger.getLoggerLevel());

        loggerWrapper.setLogLevel(3);
        assertEquals(LDSDKLogger.LoggerLevel.LOGGER_LEVEL_WARN, logger.getLoggerLevel());

        loggerWrapper.setLogLevel(4);
        assertEquals(LDSDKLogger.LoggerLevel.LOGGER_LEVEL_ERROR, logger.getLoggerLevel());

        // TODO [bhy]: consider FATAL logger level - both iOS and Unity wrappers support them
    }

}
