package dk.lego.devicesdk;

public class LDSDKError extends RuntimeException {

    public enum ErrorCode {
        INTERNAL_ERROR(1),
        BLUETOOTH_CONNECTION_TIMEOUT(10),
        BLUETOOTH_CONNECTION_ERROR(11),
        BLUETOOTH_UNSUPPORTED_FIRMWARE_VERSION(50),
        BLUETOOTH_UNKNOWN_SERVICE_UUID(100),
        BLUETOOTH_MISSING_CHARACTERISTICS(105),
        BLUETOOTH_INVALID_CHARACTERISTIC_PROPERTIES(110);

        int value;

        ErrorCode(int value) {
            this.value = value;
        }
    }

    private final ErrorCode errorCode;

    public static LDSDKError deviceError(ErrorCode errorCode, String message) {
        return new LDSDKError(message, errorCode, null);
    }

    LDSDKError(String message, ErrorCode errorCode, Throwable exception) {
        super(message, exception);
        this.errorCode = errorCode;
    }

    public ErrorCode getErrorCode() {
        return errorCode;
    }
}
