package dk.lego.devicesdk.bluetooth.service_definitions;

import java.util.UUID;

import dk.lego.devicesdk.bluetooth.BluetoothHelper;

public class BatteryServiceDefinition extends BluetoothServiceDefinition {

    private static final String BATTERY_SERVICE_UUID = "0x180F";

    private static final String BATTERY_LEVEL_CHARACTERISTIC_UUID = "0x2A19";

    private static BatteryServiceDefinition instance = null;
    private CharacteristicDefinition batteryLevel;

    private BatteryServiceDefinition() {
    }

    public static BatteryServiceDefinition getInstance() {
        if (instance == null) {
            instance = new BatteryServiceDefinition();
            instance.init();
        }
        return instance;
    }


    void init() {
        serviceUUID = UUID.fromString(BluetoothHelper.UUIDWithPrefixStandardBase(BATTERY_SERVICE_UUID));
        serviceName = "BatteryService";

        batteryLevel = new CharacteristicDefinition(
                "InputValues",
                this,
                UUID.fromString(BluetoothHelper.UUIDWithPrefixStandardBase(BATTERY_LEVEL_CHARACTERISTIC_UUID)),
                true,
                (BluetoothHelper.Properties.PROPERTY_NOTIFY.ordinal() | BluetoothHelper.Properties.PROPERTY_NOTIFY.ordinal()),
                0,
                BluetoothHelper.Permissions.PERMISSION_READ.ordinal());

        characteristicDefinitions.add(batteryLevel);
    }

    public CharacteristicDefinition getBatteryLevel() {
        return batteryLevel;
    }

    @Override
    public boolean equals(Object o) {
        return super.equals(o);
    }

    @Override
    public int hashCode() {
        return super.hashCode();
    }
}
