package dk.lego.devicesdk.bluetooth.wrappers;

/**
 * Android BluetoothAdapter wrapper
 */
public interface AndroidBluetoothAdapterWrapper {
    /**
     * Start Bluetooth LE scan
     */
    public void startLeScan();

    /**
     * Stop Bluetooth LE scan
     */
    public void stopLeScan();

    /**
     * Is Bluetooth available on device
     */
    public boolean isBluetoothAvailable();

    /**
     * Is Bluetooth enabled on device
     */
    public boolean isBluetoothEnabledOnDevice();

    /**
     * Connect listener to adapter - allowing for callbacks whenever an LE scan result is available
     * @param listener The listener
     */
    public void connectCallbackListener(AndroidBluetoothScanCallbackListener listener);
}
