package dk.lego.devicesdk.bluetooth.wrappers;

import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGattCallback;
import android.content.Context;

/**
 * Android BluetoothDevice wrapper
 */
public interface AndroidBluetoothDeviceWrapper {
    /**
     * Name wrapper
     *
     * @return Name of the Bluetooth device
     */
    public String getName();

    /**
     * Adress wrapper
     *
     * @return MAC address of the Bluetooth device
     */
    public String getAddress();

    /**
     * Wraps the Android connectGatt method used to connect and interrogate Bluetooth LE devices
     *
     * @param context Android application context
     * @param autoConnect Whether to directly connect to the remote device (false) or to automatically connect as soon as the remote device becomes available (true)
     * @param bluetoothGattCallback GATT callback handler that will receive asynchronous callbacks
     */
    void connectGatt(Context context, boolean autoConnect, BluetoothGattCallback bluetoothGattCallback);

    /**
     * @return The Android Bluetooth abstraction
     */
    public BluetoothDevice getDevice();
}
