package dk.lego.devicesdk.bluetooth.wrappers;

import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGattCallback;
import android.content.Context;

public class AndroidBluetoothDeviceWrapperImpl implements AndroidBluetoothDeviceWrapper {
    private final BluetoothDevice bluetoothDevice;

    public AndroidBluetoothDeviceWrapperImpl(BluetoothDevice bluetoothDevice) {
        this.bluetoothDevice = bluetoothDevice;
    }

    @Override
    public BluetoothDevice getDevice() {
        return bluetoothDevice;
    }

    @Override
    public String getName() {
        return bluetoothDevice.getName();
    }

    @Override
    public String getAddress() {
        return bluetoothDevice.getAddress();
    }

    @Override
    public void connectGatt(Context context, boolean autoConnect, BluetoothGattCallback bluetoothGattCallback) {
        bluetoothDevice.connectGatt(context, autoConnect, bluetoothGattCallback);
    }
}
