package dk.lego.devicesdk.input_output;

import dk.lego.devicesdk.bluetooth.IoCallbackHelper;
import dk.lego.devicesdk.bluetooth.LegoBluetoothDevice;

public abstract class IO {
    protected LegoBluetoothDevice associatedDevice;
    protected IoCallbackHelper callbackHelper = new IoCallbackHelper();

    public abstract void writeInputFormat(InputFormat newFormat, int connectId);
    public abstract void readInputFormatForConnectId(int connectId);
    public abstract void writeMotorPower(int power, int connectId);
    public abstract void writeMotorPower(int power, int offset, int connectId);
    public abstract void writePiezoToneFrequency(int frequency, int duration, int connectId);
    public abstract void writePiezoToneStop(int connectId);
    public abstract void writeColor(int red, int green, int blue, int connectId);
    public abstract void writeColorIndex(int index, int connectId);
    public abstract void writeData(byte[] data, int connectId);
    public abstract void readValueForConnectId(int connectId);
    public abstract void resetStateForConnectId(int connectId);

    public void registerCallbackListener(IOCallbackListener callbackListener) {
        assert(callbackListener != null);
        callbackHelper.registerCallbackListener(callbackListener);
    }

    public void unregisterCallbackListener(IOCallbackListener callbackListener) {
        assert(callbackListener != null);
        callbackHelper.unregisterCallbackListener(callbackListener);
    }
}
