package dk.lego.devicesdk.services;

/**
 * Implement this callback listener to be notified when the {@link dk.lego.devicesdk.services.CurrentSensor} updates its value
 */
public interface CurrentSensorCallbackListener extends ServiceCallbackListener {
    /**
     * Invoked when the {@link dk.lego.devicesdk.services.CurrentSensor} receives an updated value
     *
     * @param sensor     The sensor that has a new value
     * @param milliAmps The new current value in milli amps
     */
    public void didUpdateMilliAmps(CurrentSensor sensor, float milliAmps);
}
