package dk.lego.devicesdk.services;

/**
 Implement this protocol to be notified when the MotionSensor updates its value
 */

public interface MotionSensorCallbackListener extends ServiceCallbackListener {

    /**
     * Invoked when the motion sensor has an updated distance value
     *
     * @param sensor      The sensor that has a new value
     * @param oldDistance The previous distance reading
     * @param newDistance The new distance reading
     */
    public void didUpdateDistance(MotionSensor sensor, float oldDistance, float newDistance);

    /**
     * Invoked when the motion sensor has an updated count value
     *
     * @param sensor The sensor that has a new value
     * @param count  The new value
     */
    public void didUpdateCount(MotionSensor sensor, int count);
}
