package dk.lego.devicesdk.services;

/**
 * Implement this listener to be notified when the TiltSensor updates its value
 */

public interface TiltSensorCallbackListener extends ServiceCallbackListener {
    /**
     * Invoked when the tilt sensor has an updated value for direction.
     *
     * @param sensor       The tilt sensor
     * @param oldDirection The previous direction
     * @param newDirection The new direction
     */
    public void didUpdateDirection(final TiltSensor sensor, TiltSensor.TiltSensorDirection oldDirection, TiltSensor.TiltSensorDirection newDirection);

    /**
     * Invoked when the tilt sensor has an updated value for angle.
     *
     * @param sensor   The tilt sensor
     * @param oldAngle The old angle
     * @param newAngle The new angle
     */
    public void didUpdateAngle(final TiltSensor sensor, TiltSensor.TiltSensorAngle oldAngle, TiltSensor.TiltSensorAngle newAngle);

    /**
     * Invoked when the tilt sensor has an updated value for crash readings.
     *
     * @param sensor        The tilt sensor
     * @param oldCrashValue The previous value
     * @param newCrashValue The new crash value
     */
    public void didUpdateCrash(final TiltSensor sensor, TiltSensor.TiltSensorCrash oldCrashValue, TiltSensor.TiltSensorCrash newCrashValue);
}
