package dk.lego.devicesdk.services;

/**
 * Implement this callback listener to be notified when the {@link dk.lego.devicesdk.services.VoltageSensor} updates its value
 */
public interface VoltageSensorCallbackListener extends ServiceCallbackListener {
    /**
     * Invoked when the {@link dk.lego.devicesdk.services.VoltageSensor} receives an updated value
     *
     * @param sensor     The sensor that has a new value
     * @param milliVolts The new voltage value in milli volts
     */
    public void didUpdateMilliVolts(VoltageSensor sensor, float milliVolts);
}
