package dk.lego.devicesdk.unity;

import dk.lego.devicesdk.logging.LDSDKLogger;

public class LegoLoggerWrapperImpl implements LegoLoggerWrapper {

    private static LegoLoggerWrapperImpl instance = null;

    private LDSDKLogger logger;

    public static LegoLoggerWrapperImpl getInstance() {
        if (instance == null) {
            instance = new LegoLoggerWrapperImpl();
        }
        return instance;
    }

    private LegoLoggerWrapperImpl() {
        this(LDSDKLogger.getInstance());
    }

    LegoLoggerWrapperImpl(LDSDKLogger logger) {
        this.logger = logger;
    }

    @Override
    public void setLogLevel(int level) {
        logger.setLogLevel(LDSDKLogger.LoggerLevel.fromInteger(level));
    }

}
