package dk.lego.devicesdk.unity;

public interface LegoServiceWrapper {
    void updateServiceData(String legoDeviceID, String connectID);
    void updateInputFormat(String legoDeviceID, String connectID, String mode, String unit, String deltaInterval, boolean notificationEnabled);
    void run(String legoDeviceID, String connectID, String motorDirection, String power);
    void brake(String legoDeviceID, String connectID);
    void drift(String legoDeviceID, String connectID);
    void setRGBLightMode(String legoDeviceID, String connectID, String rgbLightMode);
    void switchOff(String legoDeviceID, String connectID);
    void changeColor(String legoDeviceID, String connectID, String colorJSON);
    void changeColorToDefault(String legoDeviceID, String connectID);
    void changeColorIndex(String legoDeviceID, String connectID, String colorIndex);
    void setMotionSensorMode(String legoDeviceID, String connectID, String motionSensorMode);
    void setTiltSensorMode(String legoDeviceID, String connectID, String tiltSensorMode);
    void playFrequency(String legoDeviceID, String connectID, String frequency, String milliseconds);
    void playNote(String legoDeviceID, String connectID, String note, String octave, String milliseconds);
    void stopPlaying(String legoDeviceID, String connectID);
}
