package dk.lego.devicesdk.unity;

import android.util.Log;

import java.lang.reflect.Method;
import java.util.Map;

public class UnityInvoker {

    private Method sendMessageMethod;
    private WrapperSerialization wrapperSerialization = new WrapperSerialization();

    public UnityInvoker() {
        try {
            Class<?> playerClass = Class.forName("com.unity3d.player.UnityPlayer");
            sendMessageMethod = playerClass.getMethod("UnitySendMessage", String.class, String.class, String.class);
        } catch (Exception e) {
            Log.e("LEGODeviceSDK", "Failed to initialize UnityInvoker - invoking Unity methods will not be possible: " + e.toString());
            throw new RuntimeException("Failed to initialize UnityInvoker", e);
        }
    }

    public void invokeMethod(String methodName, Map<String, Object> dataMap) {
        Log.d("LEGODeviceSDK", "Invoke Unity method: " + methodName + " with data: " + (dataMap != null ? dataMap : "(none)"));
        try {
            sendMessageMethod.invoke(null, "LEGODeviceManager", methodName, dataMap != null ? wrapperSerialization.mapToJSONString(dataMap) : "");
        } catch (Exception e) {
            Log.e("LEGODeviceSDK", "Failed to invoke Unity method " + methodName + ": " + e.toString());
            e.printStackTrace();
        }
    }

}
