package dk.lego.devicesdk.utils;

import android.os.Handler;

public class HandlerHelper {
    private static HandlerHelper instance;

    private Handler mainHandler = null;

    private HandlerHelper() {
    }

    public static HandlerHelper getInstance() {
        if (instance == null) {
            instance = new HandlerHelper();
        }

        return instance;
    }

    public void setMainHandler(Handler handler) {
        this.mainHandler = handler;
    }

    public void post(Runnable runnable) {
        if (mainHandler != null) {
            mainHandler.post(runnable);
        }
    }

    public void postDelayed(Runnable runnable, long interval) {
        if (mainHandler != null) {
            mainHandler.postDelayed(runnable, interval);
        }
    }

    public void removeCallbacks(Runnable runnable) {
        if (mainHandler != null) {
            mainHandler.removeCallbacks(runnable);
        }
    }
}
